$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! clinkCommand.dcl
$!
$! Note: In order to support both shareable and executable images, the first
$! argument must be either /Shar=name or /Exec=name.
$!
$ executableQual	= p1
$ if f$edit(f$extract(0,3,executableQual),"lowercase") .eqs. "/no"
$ then
$   executable = "NL:"
$ else
$   executable		= f$element(1,"=",executableQual)
$ endif
$ mainModule		= p2	! either file.obj or file.olb(module)
$ libList		= f$edit(p3,"compress")
$ other			= p4
$ additional1		= p5	! additional "," separated arguments
$ additional2		= p6	! ...
$ additional3		= p7
$ additional4		= p8
$!
$ libQualifiers = ""
$ libIndex = 0
$!
$loop:
$   nextLib = f$element(libIndex, " ", libList)
$   if nextLib .eqs. " " .or. nextLib .eqs. "" then goto endLoop
$   if f$parse(nextLib, "", "", "type") .eqs. ".OPT"
$   then
$     libQualifiers = libQualifiers + "," + nextLib + "/Opti"
$   else
$     if f$parse(nextLib, "", "", "type") .eqs. ".OBJ"
$     then
$       libQualifiers = libQualifiers + "," + nextLib
$     else
$       libQualifiers = libQualifiers + "," + nextLib + "/Libr"
$     endif
$   endif
$   libIndex = libIndex + 1
$ goto loop
$!
$endLoop:
$!
$ additional = ""
$ if additional1 .nes. "" then additional = additional + "," + additional1
$ if additional2 .nes. "" then additional = additional + "," + additional2
$ if additional3 .nes. "" then additional = additional + "," + additional3
$ if additional4 .nes. "" then additional = additional + "," + additional4
$!
$! convert MMS library module from lib(module=module.obj) to lib/include=module
$!
$ length = f$length(mainModule)
$ pos1 = f$locate("(", mainModule)
$ pos2 = f$locate("=", mainModule)
$ pos3 = f$locate(")", mainModule)
$ if pos1 .lt. pos2 .and. pos2 .lt. pos3 .and. pos3 .lt. length
$ then
$   library = f$extract(0, pos1, mainModule)
$   moduleFile = f$extract(pos2+1, pos3-pos2-1, mainModule)
$   mainModule = library + "/Incl=" + f$parse(moduleFile,"","","name")
$ else
$!
$!  convert MMS library module from lib(module) to lib/include=module
$!
$   if pos1 .lt. pos3 .and. pos3 .lt. length
$   then
$     library = f$extract(0, pos1, mainModule)
$     mainModule = library + f$extract(pos1+1, pos3-pos1-1,mainModule)
$   endif
$ endif
$!! corba_interfaces=""
$!! if f$search("corba_interfaces.opt") .nes. "" then-
$!!	corba_interfaces="," + f$parse("corba_interfaces.opt") + "/opt"
$ !
$ ! Move any /map qualifier to the begining of the command line due to stupid
$ ! LINK conventions (otherwise we might wind up with a map file in
$ ! sys$library).  (Sorry for the *ugly* DCL!)
$ !
$ ! look for regular expression "/map[ \t]*=[ \t]*[^, \t/]+" or "/map[ \t]*" in
$ ! symbol "other"
$ !
$ start=f$locate("/map",f$edit(other,"lowercase"))
$ if start .lt. f$length(other)
$ then
$   tab="	"
$   pos = start + 4
$   char = f$extract(pos,1,other)
$ !
$map0:	! "[ \t]*"
$ !
$   if char .nes. " " .and. char .nes. tab then goto map1
$   pos = pos+1
$   if pos .eq. f$length(other) then goto mapfinish
$   char=f$extract(pos,1,other)
$   goto map0
$ !
$map1:	! "="
$ !
$   if char .nes. "=" then goto mapfinish
$   pos = pos + 1
$   if pos .eq. f$length(other) then goto maperror  ! /map= with no filespec
$   char = f$extract(pos,1,other)
$ !
$map2:	! "[ \t]*"
$ !
$   if char .nes. " " .and. char .nes. tab then goto map3
$   pos = pos+1
$   if pos .eq. f$length(other) then goto maperror ! /map= with no filespec
$   char=f$extract(pos,1,other)
$   goto map2
$ !
$map3:	! [^ \t,/\]+ (file spec)
$ !
$   delimiters=" " + tab + ",/"
$   if f$locate(char,delimiters) .lt. f$length(delimiters) then goto mapfinish
$   pos = pos+1
$   if pos .eq. f$length(other) then goto mapfinish
$   char=f$extract(pos,1,other)
$   goto map3
$ !
$mapfinish:
$ !
$   mapqualifier=f$extract(start, pos-start, other)
$   other=other-mapqualifier
$   goto mapend
$ !
$maperror:
$ !
$   echo "Encountered bad map qualifier in ''other'"
$   mapqualifier=""
$ !
$mapend:
$ !
$ else	! no /map qualifier
$ !
$   mapqualifier=""
$ endif	! check for /map qualifier
$ !
$ echo "Linking ''executable'..."
$ oldverify=f$verify(1)
$ link'executableQual''mapqualifier' 'mainModule''corba_interfaces''additional''libQualifiers''other'
$ link_status = $status
$ x=f$verify(oldverify)
$ exit 'link_status'
