$! Export.dcl: copy source to target directory if needed.
$!
$ sourceFileSpec = f$parse(p1,";")
$ targetDir = p2
$!
$ if f$search(targetDir + "*.*") .eqs. "" then create/dir 'targetDir'
$ targetFileSpec = f$parse(sourceFileSpec,"","","name") +-
		   f$parse(sourceFileSpec,"","","type")
$ targetFileSpec = f$parse(targetFileSpec,targetDir,";")
$ if f$search(targetFileSpec) .eqs. ""
$ then
$   set noon
$   oldver=f$verify(1)
$   backup 'sourceFileSpec' 'targetDir'/log/new
$   backup_status = $status
$   x=f$verify(oldver)
$   if .not. backup_status
$   then
$     sho symbol backup_status
$     write sys$output f$message(backup_status)
$     exit 'backup_status'
$   endif
$ else
$   sourceDate = f$cvtime(f$file_attributes(sourceFileSpec, "RDT"))
$   targetDate = f$cvtime(f$file_attributes(targetFileSpec, "RDT"))
$   if sourceDate .gts. targetDate
$   then
$     ! It's annoying to do superfluous builds, so check to see if the header
$     ! really changed:
$     diff 'sourceFileSpec' 'targetFileSpec'/output=nl:
$     if $status .ne. %X006C8009
$     then
$	set noon
$	backup 'sourceFileSpec' 'targetDir'/log/new
$	backup_status = $status
$	if .not. backup_status
$	then
$	  sho symbol backup_status
$	  write sys$output f$message(backup_status)
$	  exit 'backup_status'
$	endif
$     endif
$   endif
$ endif
