$ self_=f$environment("procedure")
$ here_=f$parse(self_,,,"device")+f$parse(self_,,,"directory")
$ there_=f$parse(self_,,,"device")+f$parse(self_,,,"directory")-"mk]"
$!
$ echo=="write sys$output"
$ BINPATH = P1
$ PLATFORM = P2
$ LIBPATH = P3
$!
$! check platform:
$!
$ os_name = f$element(0, "_", platform)
$ hardware_name = f$edit(f$element(1, "_", platform),"UPCASE")
$ os_version_major = f$element(2,"_",platform)
$ os_version_minor = f$element(3,"_",platform)
$ os_version = "V" + os_version_major + "." + os_version_minor
$!
$ platform_status = 1
$ if f$edit(os_name,"UPCASE") .nes. "OPENVMS"
$ then
$   echo "Platform MMS macro ""''platform'"" not configured for OpenVMS."
$   platform_status = 0
$ endif
$!
$ arch_name = f$edit(f$getsyi("arch_name"),"UPCASE")
$ if arch_name .nes. hardware_name
$ then
$   echo "Platform MMS macro ""''platform'"" does not match ""''arch_name'""."
$   platform_status = 0
$ endif
$!
$ syi_version = f$edit(f$getsyi("version"),"UPCASE,COLLAPSE")
$! remove patch level release:
$ syi_version = f$extract(0, f$locate("-",syi_version),syi_version)
$ if syi_version .nes. os_version
$ then
$   echo "Platform MMS macro ""''platform'"" does not match ""''syi_version'""."
$   platform_status = 0
$ endif
$!
$ if .not. platform_status
$ then
$   echo "See ''there_'config]config.mms."
$   echo "Note: if you are using autoconfig, you can do a make reconfigure"
$   exit 'platform_status'
$ endif
$ !
$ define/nolog omniMk 'here_'
$ ! ...
$
$ call checkdir "''binpath'"
$ call checkdir "''libpath'"
$
$ bindevice=f$parse(binpath,,,"device")
$ bindirectory=f$parse(binpath,,,"directory")
$ define/nolog omniexe 'bindevice''bindirectory'
$
$ ! omnilib logical for dcl commands:
$
$ libdevice = f$parse(LIBPATH,"","","device")
$ libdirectory = f$parse(LIBPATH,"","","directory")
$ define/nolog omnilib 'libdevice''libdirectory'
$
$ ! Note that share.opt is only needed on VMS 6.x
$
$ if os_version_major .eqs. "6" .and.-
	f$search("omnilib:share.opt") .eqs. "" then-
	copy [mk.platforms]'platform'.opt omnilib:share.opt
$ if f$type(useTcpSocketVaxRoutines) .eqs. "INTEGER"
$ then
$   if useTcpSocketVaxRoutines .and. f$getsyi("version") .lts. "V7.0"
$   then
$     DEFINE/nolog DECC$CRTLMAP SYS$LIBRARY:DECC$CRTL.EXE
$     DEFINE/nolog LNK$LIBRARY  SYS$LIBRARY:DECC$CRTL.OLB
$	! note that this latter define is worthless at DEC C++ 5.6.  See
$	! PLATFORM_CXXLINKFLAGS in (e.g.) [mk.platforms]openvms_vax_6_1.mk
$   endif
$ endif
$
$ define/nolog dcl$path omniexe,omnimk
$
$ if p4 .nes. ""
$ then p4
$ endif
$
$ ! Try to eliminate interference from existing logical names
$
$ call zapname "OMNITHREAD_RT"
$ call zapname "OMNITHREAD_RTD"
$ call zapname "OMNIORB4_RT"
$ call zapname "OMNIORB4_RTD"
$ call zapname "OMNIDYNAMIC4_RT"
$ call zapname "OMNIDYNAMIC4_RTD"
$
$ ! Add some more logicals to conserve characters on the command line.
$ ! These are used in buildcorbastubs.dcl.
$
$ define/nolog corbastubs 'there_'stub]
$ define/nolog corbaidls [],'there_'idl]
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ zapname: subroutine
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ set noon
$ thename = p1
$ if f$trnlnm(thename).nes.""
$ then
$   oldver=f$verify(1)
$   deassign 'thename'
$   x=f$verify(oldver)
$ endif
$ set on
$
$ endsubroutine		! zapname
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ checkdir: subroutine
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ thePath = p1
$ theDevice = f$parse(thePath,"","","device")
$ theDirectory = f$parse(thePath,"","","directory")
$ dirElements = theDirectory - "[" - "]"
$
$ dirFile=theDevice + "["
$ prev=""
$ idx = 0
$ next=f$element(idx, ".", dirElements)
$ more:
$
$   element=next
$   if element .eqs. "." then goto nomore
$   if prev .nes. ""
$   then
$     dirFile = dirFile + prev
$   endif
$   idx = idx + 1
$   next=f$element(idx, ".", dirElements)
$   if prev .nes. "" .and. next .nes. "." then dirFile = dirFile + "."
$   prev=element
$   goto more
$
$ nomore:
$
$ if idx .eq. 1 then dirFile = dirFile + "000000"
$ dirFile = dirFile + "]" + prev + ".dir"
$ if f$search(dirFile) .eqs. "" then create/directory 'thePath'
$ endsubroutine		! checkdir
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
