$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ unixtovmsdir: subroutine	! convert UNIX style directory names to VMS
$				! format.
$
$	! Takes unix style or vms style directory name as its only argument.
$
$	! if the argument contains any colons (:) or braces ([]) then the
$	! argument is assumed to be a VMS directory name and is returned
$	! without modification.
$
$	! Otherwise, the argument is converted to a VMS style specification.
$
$	! The result is returned in the global variable outputdir.
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$   arg = f$edit(p1,"TRIM,COMPRESS")
$   outputdir == ""
$
$   ! if argument looks like a vms name then return it without modification:
$
$   if	f$locate(":",arg) .lt. f$length(arg) .or.-
	f$locate("[",arg) .lt. f$length(arg) .or.-
	f$locate("]",arg) .lt. f$length(arg)
$   then
$     outputdir == arg
$     goto u2vms_end
$   endif
$
$   ! degenerate cases
$
$   if arg .eqs. ""
$   then
$     outputdir == ""
$     goto u2vms_end
$   endif
$
$   if arg .eqs. "/"
$   then
$     outputdir == "[000000]"
$     goto u2vms_end
$   endif
$
$   ! to make life easier, if the argument ends with a slash then remove it
$
$   if f$extract(f$length(arg)-1,1,arg) .eqs. "/"
$   then
$     arg = f$extract(0,f$length(arg)-1,arg)
$   endif
$
$   idx=0
$   sub1=f$element(idx,"/",arg)		! previous subdirectory
$
$   idx = idx + 1
$   sub2 = f$element(idx,"/",arg)	! next subdirectory
$
$   ! sub2 .eqs. "/" indicates the end of the string has been found.
$   ! Note that it is imposible for f$element(0, delim, x) to return delim.
$
$   if sub2 .eqs. "/"		! ^[^/]+$ (no slash found)
$   then
$
$     if sub1 .eqs. "."		! ^\.$
$     then
$	outputdir=="[]"
$	goto u2vms_end
$     endif
$
$     if sub1 .eqs. ".."	! ^\.\.$
$     then
$	outputdir=="[-]"
$	goto u2vms_end
$     endif
$
$     ! no slashes found and the parameter was not one of the above special
$     ! cases. Unfortunately, this has more than one interpretation.  If the
$     ! paramter exists as a logical name then it should be interpreted as a
$     ! device name.  The other interpretation is [.name].  I think I'll give
$     ! this precedence (it's less "global").
$
$     if f$search(arg + ".dir") .eqs. ""
$     then
$	outputdir=="[." + arg + "]"
$     else
$	outputdir==arg + ":"
$     endif
$
$     goto u2vms_end
$
$   endif
$
$   ! found at least one slash.
$
$   if sub1 .eqs. ""		! ^/
$   then
$
$     ! leading slash indicates a VMS device name follows
$
$     if sub2 .eqs. ""		! ^/$ or ^//
$     then
$
$	! advance sub1 and sub2
$	sub1 = sub2
$	idx=idx + 1
$	sub2 = f$element(idx,"/",arg)
$
$	if sub2 .eqs. "/"	! ^/$
$	then
$	  ! not sure how to interpret this.  sys$login: is a tempting
$	  ! interpretation, but I think ~ or /~ would be closer (which isn't
$	  ! handled).
$	  outputdir=="[000000]"
$	  goto u2vms_end
$
$	else		      ! ^//
$
$	  ! cygwin interprets //c as c: so do something similar (but don't
$	  ! bother looking for something stupid like //., //.. or /// - just
$	  ! let it blow up).
$	  outputdir == sub2 + ":"
$	  ! advance sub1 and sub2
$	  sub1 = sub2
$	  idx = idx + 1
$	  sub2 = f$element(idx,"/",arg)
$	  if sub2 .eqs. "/" then goto u2vms_end
$
$	endif
$
$     else			! ^/[^/]+
$
$	! advance
$	sub1 = sub2
$	idx = idx + 1
$	sub2 = f$element(idx,"/",arg)
$	outputdir == sub1 + ":"
$
$	if sub2 .eqs. "/" then goto u2vms_end
$
$	! advance
$	sub1 = sub2
$	idx = idx + 1
$	sub2 = f$element(idx,"/",arg)
$
$     endif
$
$   endif
$
$   outputdir==outputdir + "["
$
$   u2vms_next:
$
$   if sub1 .eqs. "."
$   then
$     outputdir == outputdir + "."
$   else
$     if sub1 .eqs. ".."
$     then
$	outputdir == outputdir + "-"
$     else
$	! special case: sub1/sub2 -> [.sub1.sub2]
$	if idx .eq. 1
$	then
$	  outputdir == outputdir + "." + sub1
$	else
$	  outputdir == outputdir + sub1
$	endif
$	if sub2 .nes. "/" then outputdir == outputdir + "."
$     endif
$   endif
$
$   if sub2 .eqs. "/"
$   then
$     outputdir == outputdir + "]"
$     goto u2vms_end
$   endif
$
$   ! advance sub1 and sub2
$
$   sub1 = sub2
$   idx=idx+1
$   sub2 = f$element(idx,"/",arg)
$   goto u2vms_next
$
$   u2vms_end: exit
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ endsubroutine !unixtovmsdir
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
