# dir.mms for omniORB
#
SUBDIRS = orbcore dynamic codesets

# Note that the MMS version of the makefiles don't build omniidl_be
# via $(MakeSubDirs).  Rather, the export of the python files to
# $(TOP)/lib/python is accomplished via $(ExportPythonFiles) below.

headers = distdate.hh\
	Naming.hh\
	corbaidl_defs.hh\
	corbaidl_operators.hh\
	corbaidl_poa.hh\
	ir_defs.hh\
	ir_operators.hh\
	ir_poa.hh\
	bootstrap.hh

localHeaders=$(foreach header,$(headers),[.omniORB4]$(header) )

omniORBInclude_V=$(SUBST ..,-,$(EXPORT_TREE)/include/omniORB4)
omniORBInclude_V=$(SUBST /,.,$(omniORBInclude_V))
omniORBInclude_V=[$(SUBST .-,-,$(omniORBInclude_V))]

exportHeaders=$(foreach header,$(headers),$(omniORBInclude_V)$(header) )

all :: $(localHeaders)

clean ::
	@ $(MakeSubdirs)

distdate_header = $(omniORBInclude_V)distdate.hh
Naming_header = $(omniORBInclude_V)Naming.hh
bootstrap_header = $(omniORBInclude_V)bootstrap.hh
ir_defs_header = $(omniORBInclude_V)ir_defs.hh
ir_operators_header = $(omniORBInclude_V)ir_operators.hh
ir_poa_header = $(omniORBInclude_V)ir_poa.hh
corbaidl_defs_header = $(omniORBInclude_V)corbaidl_defs.hh
corbaidl_operators_header = $(omniORBInclude_V)corbaidl_operators.hh
corbaidl_poa_header = $(omniORBInclude_V)corbaidl_poa.hh

export :: $(localHeaders) $(exportHeaders)
	@ $(ExportPythonFiles)
	@ $(MakeSubdirs)

tlist1_=.idl .hh SK.cc DynSK.cc
tlist2_=.idl _defs.hh _operators.hh SK.cc DynSK.cc

veryclean ::
	$(VERBOSITY) $(RM) $(foreach f,\
 $(foreach t,$(tlist1_),Naming$(t) ),[.omniORB4]$(f) )
	$(VERBOSITY) $(RM) $(foreach f,\
 $(foreach t,$(tlist1_),bootstrap$(t) ),[.omniORB4]$(f) )
	$(VERBOSITY) $(RM) [.omniORB4]distdate.hh
	$(VERBOSITY) $(RM) $(foreach f,\
 $(foreach t,.$(tlist2_),ir$(t) ),[.omniORB4]$(f) )
	$(VERBOSITY) $(RM) $(foreach f,\
 $(foreach t,$(tlist2_),corbaidl$(t) ),[.omniORB4]$(f) )

######################################################################
# Make rules for Stubs                                               #
######################################################################
OMNIORB_IDL_FLAGS=-DHAS_LongLong
OMNIORB_IDL = $(OMNIORB_IDL) -p$(BASE_OMNI_TREE)/src/lib/omniORB -Wbdebug\
 $(OMNIORB_IDL_FLAGS)

checkdir=if f$search("omniORB4.dir").eqs."" then\
	create/dir/log [.omniORB4]/prot=(o:rwd,w:r)

UPDATELOG_V=$(SUBST ..,-,$(BASE_OMNI_TREE))
UPDATELOG_V=$(SUBST /,.,$(UPDATELOG_V))
UPDATELOG_V=[$(SUBST .-,-,$(UPDATELOG_V))]update.log

[.omniORB4]distdate.hh : $(UPDATELOG_V)
	$(checkdir)
	@distdate.dcl

[.omniORB4]Naming.hh : Naming.idl
	$(checkdir)
	$(OMNIORB_IDL) -v -ComniORB4 Naming.idl

[.omniORB4]bootstrap.hh : bootstrap.idl
	$(checkdir)
	$(OMNIORB_IDL) -v -ComniORB4 bootstrap.idl

[.omniORB4]ir_defs.hh [.omniORB4]ir_operators.hh [.omniORB4]ir_poa.hh :\
 ir.idl corbaidl.idl
	$(checkdir)
	$(OMNIORB_IDL) -v -WbF -ComniORB4 "-I./" ir.idl

[.omniORB4]corbaidl_defs.hh\
 [.omniORB4]corbaidl_operators.hh\
 [.omniORB4]corbaidl_poa.hh : corbaidl.idl
	$(checkdir)
	$(OMNIORB_IDL) -v -WbF -ComniORB4 corbaidl.idl


# Make rules to import idls from ['top'.idl]
IDLPATH_V=$(SUBST ..,-,$(IMPORT_TREES)/idl)
IDLPATH_V=$(SUBST /,.,$(IDLPATH_V))
IDLPATH_V=[$(SUBST .-,-,$(IDLPATH_V))]

Naming.idl : $(IDLPATH_V)Naming.idl
	backup/log/new $< []

bootstrap.idl : $(IDLPATH_V)bootstrap.idl
	backup/log/new $< []

ir.idl : $(IDLPATH_V)ir.idl
	backup/log/new $< []

corbaidl.idl : $(IDLPATH_V)corbaidl.idl
	backup/log/new $< []

######################################################################
# Make rules for Exporting headers                                   #
######################################################################
$(distdate_header) : [.omniORB4]distdate.hh
	@ $(ExportHeader)

$(Naming_header) : [.omniORB4]Naming.hh
	@ $(ExportHeader)

$(bootstrap_header) : [.omniORB4]bootstrap.hh
	@ $(ExportHeader)

$(ir_defs_header) : [.omniORB4]ir_defs.hh
	@ $(ExportHeader)

$(ir_operators_header) : [.omniORB4]ir_operators.hh
	@ $(ExportHeader)

$(ir_poa_header) : [.omniORB4]ir_poa.hh
	@ $(ExportHeader)

$(corbaidl_defs_header) : [.omniORB4]corbaidl_defs.hh
	@ $(ExportHeader)

$(corbaidl_operators_header) : [.omniORB4]corbaidl_operators.hh
	@ $(ExportHeader)

$(corbaidl_poa_header) : [.omniORB4]corbaidl_poa.hh
	@ $(ExportHeader)

show ::
	! localheaders=$(localheaders)