// -*- Mode: C++; -*-
//                            Package   : omniORB
// corbaIEEEFloat.cc          Created on: 23/04/98
//                            Author    : 
//
//    Copyright (C) 1996-1999 AT&T Laboratories Cambridge
//
//    This file is part of the omniORB library
//
//    The omniORB library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Library General Public
//    License as published by the Free Software Foundation; either
//    version 2 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Library General Public License for more details.
//
//    You should have received a copy of the GNU Library General Public
//    License along with this library; if not, write to the Free
//    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
//    02111-1307, USA
//
//
// Description:
//	Float and Double conversion operators for OpenVMS.
//	This file is specific to OpenVMS.
//

/* 
   $Log: corbaFloat.cc,v $
   Revision 1.4  1999/07/27 15:38:54  bcv
   Extracted from corbaFloat.cc for redesign

   Revision 1.3  1999/03/11 16:25:52  djr
   Updated copyright notice

   Revision 1.2  1998/08/14 13:44:04  sll
   Added pragma hdrstop to control pre-compile header if the compiler feature
   is available.

   Revision 1.1  1998/08/11 16:39:41  sll
   Initial revision

*/

#include <string.h>		// for memcpy
#include <omniORB4/CORBA_sysdep.h>
#include <omniORB4/CORBA_basetypes.h>

#ifdef HAS_pch
#pragma hdrstop
#endif

#if !defined(__VMS) 
#error "This module is intended only for VMS"
#endif

#if !__IEEE_FLOAT
#error "This module must be compiled with /Float=IEEE"
#endif

void _CORBA_Float::cvt_ieee_(float f) {
  memcpy(&pd_f, &f, sizeof(pd_f));
}

float _CORBA_Float::cvt_ieee_() const {
  float f;
  memcpy(&f, &pd_f, sizeof(f));
  return f;
}

void _CORBA_Double::cvt_ieee_(double d) {
  memcpy(&pd_d, &d, sizeof(pd_d));
}

double _CORBA_Double::cvt_ieee_() const {
  double d;
  memcpy(&d, &pd_d, sizeof(d));
  return d;
}

